Cette page explique comment sécuriser une instance App Engine avec Identity-Aware Proxy (IAP).
Avant de commencer
Pour activer IAP pour App Engine, procédez comme suit :
Utilisez un projet de console Google Cloud pour lequel la facturation est activée.
Assurez-vous que le projet appartient à une organisation Google Cloud si vous souhaitez utiliser le client OAuth par défaut géré par Google. Si vous n'avez pas d'organisation, vous pouvez en créer une. Pour en savoir plus sur les avantages de l'utilisation d'un client OAuth personnalisé, consultez Configurer des clients OAuth personnalisés pour App Engine. Le client OAuth géré par Google n'autorise l'accès qu'aux utilisateurs internes.
Configurez votre instance App Engine, si ce n'est pas déjà fait. Pour obtenir un tutoriel complet, consultez Déployer sur App Engine.
Activer IAP
Console
Si votre projet n'appartient pas à une organisation, vous devez utiliser des identifiants OAuth personnalisés.
If you haven't configured your project's OAuth consent screen, you'll be prompted to do so. To configure your OAuth consent screen, see Setting up your OAuth consent screen.
Setting up IAP access
-
Go to the
Identity-Aware Proxy page.
Go to the Identity-Aware Proxy page - Select the project you want to secure with IAP.
- Select the checkbox next to the resource you want to grant access to.
- On the right side panel, click Add principal.
-
In the Add principals dialog that appears, enter the email addresses of groups or
individuals who should have the IAP-secured Web App User role for the project.
The following kinds of principals can have this role:
- Google Account: user@gmail.com
- Google Group: admins@googlegroups.com
- Service account: server@example.
- Google Workspace domain: example.com
Make sure to add a Google Account that you have access to.
- Select Cloud IAP > IAP-secured Web App User from the Roles drop-down list.
- Click Save.
Turning on IAP
-
On the Identity-Aware Proxy page, under Applications,
find the application you want to restrict
access to. To turn on IAP for a resource,
-
In the Turn on IAP window that appears, click Turn On to
confirm that you want IAP to secure your resource. After you turn on
IAP, it requires login credentials for all connections to your load balancer.
Only principals with the IAP-Secured Web App User (
roles/iap.httpsResourceAccessor) role on the project will be given access.
gcloud
Before you set up your project and IAP, you need an up-to-date version of the gcloud CLI. For instructions on how to install the gcloud CLI, see Install the gcloud CLI.
-
To authenticate, use the Google Cloud CLI and run the following command.
gcloud auth login - Click the URL that appears and sign in.
- After you sign in, copy the verification code that appears and paste it in the command line.
-
Run the following command to specify the project that contains the applications that you want to protect with IAP.
gcloud config set project PROJECT_ID -
To enable IAP, run the following command.
gcloud iap web enable --resource-type=app-engine --versions=version -
Add principals who should have the IAP-secured Web App user role to the project.
gcloud projects add-iam-policy-binding PROJECT_ID \ --member=PRINCIPAL_IDENTIFIER \ --role=roles/iap.httpsResourceAccessor- Replace PROJECT_ID with your project ID.
- Replace PRINCIPAL_IDENTIFIER with the necessary principals. This can be a
type of domain, group, serviceAccount, or user. For example,
user:myemail@example.com.
After you enable IAP, you can use the gcloud CLI to modify the
IAP access policy using the IAM role
roles/iap.httpsResourceAccessor. Learn more about
managing roles and permissions.
API
Run the following command to prepare a
settings.jsonfile.cat << EOF > settings.json { "iap": { "enabled":true } } EOFRun the following command to enable IAP.
curl -X PATCH \ -H "Authorization: Bearer $(gcloud auth print-access-token)" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -d @settings.json \ "https://appengine.googleapis.com/v1/apps/PROJECT_ID?updateMask=iap"
After you enable IAP, you can use the Google Cloud CLI to modify the
IAP access policy using the IAM role
roles/iap.httpsResourceAccessor. Learn more about
managing roles and permissions.
Vous pouvez activer IAP sur un service App Engine dans votre projet. Pour rendre certains services accessibles publiquement et exiger une authentification pour d'autres, vous pouvez utiliser différents niveaux d'accès pour les services.
Pour en savoir plus, consultez Gérer l'accès avec IAP.
Pour rendre les services accessibles au public, attribuez le rôle Utilisateur de l'application Web sécurisée par IAP à allAuthenticatedUsers.
Tester l'authentification des utilisateurs
Une fois le rôle accordé, les comptes principaux peuvent accéder à l'application en s'authentifiant avec IAP. Accédez à l'URL de l'application à partir d'un compte Google auquel le rôle Utilisateur de l'application Web sécurisée par IAP (
roles/iap.httpsResourceAccessor) a été attribué.Pour tester l'accès, ouvrez une fenêtre de navigation privée dans Chrome, accédez à l'URL de l'application, puis connectez-vous lorsque vous y êtes invité. Les utilisateurs qui disposent du rôle Utilisateur de l'application Web sécurisée par IAP (
roles/iap.httpsResourceAccessor) et qui se sont authentifiés peuvent accéder à l'application. Les utilisateurs qui ne disposent pas du rôle requis ou qui ne parviennent pas à s'authentifier ne peuvent pas accéder à l'application.